/* func.h 3.0 (KIEL) 11.94 */

/* AMORE Declarations */

/* atime.c */
void newtick(/*string str, posint n*/);
void cpuclock(/*int who*/);
void resettime(/*void*/);
void tack(/*void*/);
void clock_reset(/*void*/);
 
/* buffer.c */
void initbuf(/*void*/);
char *newbuf(/*posint num, posint size*/);
void freebuf(/*void*/);
void bufmark(/*void*/);
void buffree(/*void*/);
 
 
/* comp.c */
void compdfa(/*void*/);
void compmdfa(/*void*/);
void compnfa(/*void*/);
void compenfa(/*void*/);
void compmon(/*void*/);
boole comptrans(/*void*/);
void compdclass(/*void*/);
void comprex(/*void*/);
void compsfx(/*void*/);
 
 
/* dclcomp.c */
boole idempotent(/*posint no, monoid mon*/);
void mon2dcl(/*monoid mon*/);
 
 
/* dfamdfa.c */
dfa dfamdfa(/*dfa curdfa,boole free*/);
dfa dfammdfa(/*dfa indfa,array *transformation*/);
 
/* monoid.c */ 
char *prword1(/*char **word, boole copy, posint *length, posint no, monoid mon, boole with, boole zeroone*/);
char *prword(/*posint no, monoid mon, boole with*/);
void compword(/*monoid mon, posint no*/);
posint mult(/*monoid mon, posint a, posint b*/);
void comprestofmon(/*monoid mon, dfa indfa*/);
posint monmaxlen(/*monoid mon*/);
void multtable(/*monoid mon, boole flag*/);


/* dfamon.c */
monoid dfa2mon(/*void*/);


/* relation.c */
void mon2rel(/*monoid mon*/);
void editrel(/*monoid mon*/);
void prtrel(/*monoid mon*/);
 
 
/* dir.c */
char *getref(/*char *name*/);
boole showdir(/*char *pat*/);
 
/* eddclass.c */
int computesizeofstates(/*monoid mon, posint states*/);
int imsizecompute(/*monoid mon, posint rang*/);
void initarray(/*monoid mon*/);
array cpt_image_kernel(/*monoid mon, posint no, boole flag*/);
boole dcomp(/*monoid mon, posint dc1, posint dc2*/);
void editdcl(/*monoid mon*/);
 
 
/* edfa.c */
posint edit(/*posint **buf1, boole ***buf2, mrkfin infin, posint sm, posint lm, posint stl, posint init, boole viewonly, boole nd*/);
 
/* edline.c */
void rdref(/*int row, int col, char *str, int erow, int ecol*/);
void rdnam(/*int row, int col, char *str, int erow, int ecol*/);
posint rdpnum(/*boole too0, int row, int col*/);
 
 
/* edmon.c */
void editmon(/*monoid mono, boole tab*/);
 
 
/* edrex.c */
string pitos(/*posint n*/);
void edrex(/*regex re, boole edit , boole *isreg*/);
 
 
/* fafa.c */
nfa oneinit(/*register nfa na*/);
nfa enfa2nfa(/*nfa epsa*/);
nfa dfa2nfa(/*register dfa da*/);

/* infix.c */
string infix(/*regex re, boole dc, posint *reslen*/);
 
 
/* input.c */
boole readexp(/*boole modify, char curchar*/);
boole readaut(/*boole modify, char curchar*/);
 
 
/* keybrd.c */
void evalkey(/*void*/);
 
 
/* listop.c */
void listinit(/*list *ptfirst, list *ptlast, posint no*/);
void listinsert(/*list *ptlast, posint no*/);
 
/* main.c */
void main(/*void*/);
void catchsig(/*void*/);

 
 
/* mem.c */
void freedfa(/*register dfa da*/);
void freenfa(/*register nfa na*/);
void freerex(/*register regex rx*/);
void freesf(/*register starfexp sf, boole flag, posint mno*/);
void freedcl(/*register dstruct dcl, posint i*/);
void freemon(/*register monoid mon*/);
language newlang(/*int idx*/);
void movelang(/*int a, int b*/);
ddelta newddelta(/*posint s, posint q*/);
ndelta newendelta(/*posint s, posint q*/);
ndelta newndelta(/*posint s, posint q*/);
string newrexstr(/*posint strl*/);
mrkfin newfinal(/*posint a*/);
dfa newdfa(/*void*/);
nfa newnfa(/*void*/);
regex newrex(/*void*/);
monoid newmon(/*void*/);
array newar(/*posint a*/);
boole *newbarray(/*posint a*/);
arrayofarray newarray1(/*posint a*/);
arrayofarray newarray2(/*posint a, posint b*/);
d_class newdclass(/*void*/);
dstruct newdstruct(/*void*/);
rstruct newrstruct(/*void*/);
starfexp newsfexp(/*void*/);
darray newdarray(/*posint a*/);
 
 
/* menu.c */
void headbox(/*int srow, int scol, int erow, int ecol, char *txt*/);
void maketitle(/*boole center, char *txt*/);
void drawmenu(/*char menuno*/);
void inpmenu(/*char menuno, boole flag*/);
void updatewin(/*char win*/);
 
 
/* nfadfa.c */
dfa nfa2dfa(/*nfa na*/);
dfa modnfa2dfa(/*nfa na, char** transformation*/);
 
/* nfamnfa.c */
nfa nfa2mnfa(/* nfa na, dfa b*/);      

/* nfa_sol.c */
nfa calc_sol(/* ptset** delta, boole version, gridlist fI,fII, posint G,N, 
  R,MAX, nfa f, ptset i_gr,f_gr */);

/* nfa_help.c */
nfa delsta(/* nfa inputnfa */);
nfa invers_d(/* dfa inputdfa */);

/* nfarex.c */
regex nfa2rex(/*nfa na*/);
 
/* outsfree.c */
void editsfx(/*dfa indfa, monoid mon, starfexp sfx, boole ex, boole pr*/);

/* parse.c */
PARSE_RESULT parser(/* PARSE_INPUT instruct*/);
 
/* pgcurses.c */
int getpgrow(/*void*/);
boole startprint(/*char *n, char *r, char *des*/);
boole endprint(/*void*/);
void pgclear(/*void*/);
void gohorizontal(/*void*/);
void govertical(/*void*/);
void pgaddch(/*char ch*/);
void pgmove(/*int row, int col*/);
void pgaddstr(/*string str*/);
void pgmvaddstr(/*int row, int col, string str*/);
void pgmvaddch(/*int row, int col, char ch*/);
void pggetyx(/*int *row, int *col*/);
void pghead(/*void*/);
void pgbreak(/*void*/);
 
/* postfix.c */
void expandrex(/*regex re;*/);
 
/* print.c */
void printrex(/*boole flag*/);
void printdaut(/*boole flag*/);
void printnaut(/*boole flag*/);
void printmon(/*void*/);
void printdclass(/*void*/);
void printmult(/*void*/);
void printsfx(/*void*/);
 
 
/* prtcomp.c */
void prtrex(/*regex re, boole flag*/);
void prtdaut(/*dfa d*/);
void prtnaut(/*nfa n*/);
void prtmon(/*monoid m, boole flag*/);
 
 
/* prtdcl.c */
void prtdcl(/*monoid mon*/);
 
 
/* readamr.c */
posint a2pi(/*char *str*/);
boolx rdinlan(/*char *fname, int idx*/);
 
 
/* genrexnfa.c */
nfa genrex2nfa(/*regex re*/);
 
 
/* rexnfa.c */
nfa rex2nfa(/*register regex re*/);
 
 
/* screen.c */
void mess(/*char *txt*/);
void help(/*boole pause, char *txt*/);
void prtstr(/*int r, int c, int ce, string str, int xro, int xco, int mr, boole dopg, boole enh, int *newr, int *newc*/);
int needlines(/*int c, int ce, char *str, posint length, boole lors, int xco*/);
void initcurses(/*void*/);
void endcurses(/*boole ex*/);
 
 
/* show.c */
void showdfa(/*void*/);
void showmdfa(/*void*/);
void shownfa(/*void*/);
void showregx(/*void*/);
void showgenregx(/*void*/);
void showeps(/*void*/);
void showmon(/*void*/);
void showtrans(/*void*/);
void showdclasses(/*void*/);
void showmult(/*void*/);
void showsfx(/*void*/);
 
 
/* starfree.c */
starfexp mon2sfx(/*dfa indfa, monoid mon*/);
 
 
/* win_bin.c */
nfa unionfa(/*nfa na1, nfa na2*/);
nfa concatfa(/*nfa na1, nfa na2*/);
dfa insecfa(/*dfa da1, dfa da2*/);
nfa shuffle(/*nfa na1, nfa na2*/);
dfa minusfa(/*dfa da1, dfa da2*/);
nfa leftquot(/*dfa indfa1, dfa indfa2*/);
dfa rightquot(/*dfa indfa1, dfa indfa2*/);
 
 
/* win_com.c */
void createlan(/*void*/);
void deletelan(/*void*/);
void modify(/*void*/);
void print(/*void*/);
void chgelan(/*char lanno*/);
void display(/*void*/);
void savelan(/*void*/);
void loadlan(/*boole fromscreen, char *fname*/);
 
 
/* win_one.c */
void deadsearch(/*dfa indfa, posint *deadpos, posint *deadneg, boole *pos, boole *neg*/);
boole folutest(/*dfa indfa*/);
boole sftest(/*monoid mon*/);
void proptest(/*language lan, monoid mon*/);
boole testpwt(/*monoid mon*/);
boole testdd1(/*monoid mon*/);
 
 
/* win_two.c */
boolx empty_full_lan(/*void*/);
boole equiv(/*dfa dfa1, dfa dfa2*/);
boole inclusion(/*dfa dfa1, dfa dfa2, boole inclusion*/);
 
 
/* win_una.c */
nfa starnfa(/*nfa na, boole plus*/);
dfa compldfa(/*dfa da*/);
nfa revnfa(/*nfa na*/);
dfa minL(/*dfa indfa*/);
dfa maxL(/*dfa indfa*/);
dfa pref(/*dfa indfa*/);
nfa suff(/*dfa indfa*/);
dfa simpledfa(/*boole full, posint sno*/);
 
 
/* writeamr.c */
char *pi2a(/*posint pi*/);
boolx writelan(/*int idx*/);

#ifdef DOS
/* curs.c */
void addch(/*char ch*/);
void addstr(/*string str*/);
void clear();
void move(/*int row, int col*/);
void mvaddch(/*int row, int col, char ch*/);
void mvaddstr(/*int row, int col, string str*/);
void clrtoeol();
#endif
