/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  ANSI-C-headerfile:   Raphael M. Grochtmann     Aachen, 31.07.1990         */
/*                                                                            */
/*                                                                            */
/*  Headerfile mit externen Variablen, die in main definiert wurden.          */
/******************************************************************************/



extern int	XGRMAX, YGRMAX;

/* ausschliesslich in dfa.c gebrauchte Pseudokonstanten */
extern double	ARROWLEN;	/* ( 8) Pfeillaenge */
extern double	ARREDLEN;	/* (18) Laenge der Schleife Loop */
extern double	STATELEN;	/* (12) Groesse eines Zustands (Radius) */
extern double	STSTOFFS;	/* ( 3) Abstand aeusserer Kreis von Innerem bei StopState */
extern double	CURVCONST;	/* (20) Boegen-Groesse */

/* ausschliesslich in draw.c gebrauchte Pseudokonstanten */
extern double	DIST;		/* ( 4) Allgemeiner Groessenparameter */

/* ausschliesslich in xgraph.c gebrauchte Pseudokonstanten */
extern double	TEXTWIDTH;	/* ( 6) FindTextLength: Textbreite der Beschriftung in Pixeln */
extern double	TEXTHEIGHT;	/* ( 8) FindTextBegPoint, DrawState, DrawLoop: Texthoehe der Beschriftung in Pixeln
 */
extern double	FTBGOFFS;	/* ( 2) FindTextBeginPoint, DrawLoop: Abstand Beschriftung von Kanten */
extern double	LOOPRADOFFS;	/* ( 2) DrawLoop: Offset zum Durchmesser einer Selbstschleife */
extern double	DARROFFS;	/* ( 3) DrawDoubleRedArrow: Offset fuer Abstand zwischen Doppelpfeilen */

/* in xgraph.c wird anhand des SKAL_FAKTOR bestimmt, ob Beschriftung stattfindet oder nicht */
extern double	SKAL_FAKTOR; /* Skalierungsfaktor */
