/* menu.h 3.0 (Kiel) 11.94 */

/* normal screen positions:
 * window structure:
 *      define startposition (row,col)
 *      define last row and last col (lin,len)
 *
 * LANGMENU positions
 *      special positions (no window)
 *      window regular expressions
 *      window automata
 *      window monoids
 *      window lanugages
 *      window actions
 *
 * TESTMENU positions
 *      special positions (no window)
 *      window one language
 *      window two languages
 *      (window lanugages)
 *      (window actions)
 *
 * AUTMENU positions
 *      (no window)
 */

/* window: regular expressions */
#define REXROW  3
#define REXCOL  2
#define REXLIN  9
#define REXLEN  27
 
/* window: automata */
#define AUTROW  3
#define AUTCOL  30
#define AUTLIN  11
#define AUTLEN  55
 
/* window: monoids */
#define MONROW  10 
#define MONCOL  2
#define MONLIN  15   /* --- Bordeaux : 1995 --- */
#define MONLEN  27
 
/* window: languages */
#define LANROW  3
#define LANCOL  59
#define LANLIN  14
#define LANLEN  77

/* window: actions
 * AOF  start screen-column of second com-clolumn
 * AOFF start screen-column of third com-column
 * etc
 */  
#define ACTROW  16         
#define ACTCOL  2
#define ACTLIN  20       
#define ACTLEN  77
#define AOF     16         
#define AOFF    31
#define AOFFF   45
#define AOFFFF  61
/* window: one language */
#define ONEROW  3
#define ONECOL  2
#define ONELIN  15   /* --- Bordeaux : 1995 --- */
#define ONELEN  27
#define ONEOFF  13
 
/* window: two languages */
#define TWOROW  3
#define TWOCOL  30
#define TWOLIN  14
#define TWOLEN  55





